#include <SPI.h>
#include <Wire.h>
#include <Adafruit_GFX.h>
#include <Adafruit_SSD1306.h>
#include <Fonts/FreeSerifItalic9pt7b.h>
#include <Adafruit_NeoPixel.h> //Bibli pour anneau de LED
//Pour défilement anneau LED :
#ifdef __AVR__
#include <avr/power.h>
#endif

#define SCREEN_WIDTH 128 // OLED largeur écran en pixels
#define SCREEN_HEIGHT 64 // OLED hauteur écran en pixels

#define OLED_RESET     -1 // Reset pin # (or -1 if sharing Arduino reset pin)
#define SCREEN_ADDRESS 0x3C ///< See datasheet for Address; 0x3D for 128x64, 0x3C for 128x32
Adafruit_SSD1306 display(SCREEN_WIDTH, SCREEN_HEIGHT, &Wire, OLED_RESET);

const int potPin = A0; // Nommer et situer potentiomètre sur la pin A0
int readValue;
int writeValue;

//pour l'anneau de LED
#define NEOPIXEL_PIN 6
#define NEOPIXEL_COUNT 24
Adafruit_NeoPixel ring(NEOPIXEL_COUNT, NEOPIXEL_PIN, NEO_GRB + NEO_KHZ800);

//nommer les boutons et indiquer leurs pins
const int Brouge = A1;
const int Bbleu = A2;

// sert à vérifier si LED allumées. Si isOn = true = allumées, si isOn = false = éteintes
// si isOn = true les LEDS restent allumées
bool isOn = false; // État d'allumage des LED
uint8_t lastRed = 0;
uint8_t lastGreen = 0;
uint8_t lastBlue = 0;

//pour servo 1
#include <Servo.h> // include the required Arduino library
#define servoPin 4 // Arduino pin for the servo
#define potPin A0 // Arduino pin for the potentiometer
int angle = 0; // variable to store the servo position in degrees
int reading = 0; // variable to store the reading from the analog input
Servo myservo1; // create a new object of the servo class

#define servoPin 5
Servo myservo2 ;

void setup() {
//TEXTE DE DEPART
  // put your setup code here, to run once:
  if(!display.begin(SSD1306_SWITCHCAPVCC, SCREEN_ADDRESS)) {
    for(;;); // Don't proceed, loop forever
  }

  //txt allumage
  display.clearDisplay(); // efface l'écran avant d'écrire

  display.setTextSize(1);
  display.setTextColor(WHITE);
  display.setCursor(30, 5);
  display.setFont(&FreeSerifItalic9pt7b);
  display.print("Bentolux");
  display.drawRoundRect(0,0,128,14,3,WHITE);

  display.display(); // obligatoire pour afficher à l'écran, comme un point à la phrase !

  delay(2000);

//contrôle LED
  ring.begin();
  ring.setBrightness(50);//permet de réduire la puissance lumineuse des LED
  ring.show(); // Initialize all pixels to off
  
//interrupteurs
  pinMode(Brouge, INPUT_PULLUP);
  pinMode(Bbleu, INPUT_PULLUP);
  
//servo
 myservo1.attach(servoPin);  
 myservo2.attach(servoPin);
}

void loop() {

///POTENTIOMETRE

readValue = analogRead(potPin); //Lecture valeur pot

//txt MERS
 if (readValue < 400) {
  display.clearDisplay();
  display.setTextSize(1);
  display.setTextColor(WHITE);
  display.setCursor(13, 30);
  display.setFont(&FreeSerifItalic9pt7b);
  display.print("Mers & oceans");
  display.display();
}

//txt A TOI DE JOUER
 else if (readValue >= 500 && readValue < 600) {
  display.clearDisplay();
  display.setTextSize(1);
  display.setTextColor(WHITE);
  display.setCursor(15, 30);
  display.setFont(&FreeSerifItalic9pt7b);
  display.print("A toi de jouer");
  display.display();
}

//LED pour mers
 if (readValue <300) {
       turnOnPixels(0, 0, 255); // Bleu
 }

//LED off, pour milieu
if (readValue >= 300 && readValue < 500) {
   turnOffPixels();
}  
if (readValue >= 600 && readValue < 700) {
   turnOffPixels();
}  

//txt EAUX DOMESTIQUES
 else if (readValue >= 600 && readValue < 1000) {
  display.clearDisplay();
  display.setTextSize(1);
  display.setTextColor(WHITE);
  display.setCursor(1, 30);
  display.setFont(&FreeSerifItalic9pt7b);
  display.print("Eaux domestiques");
  display.display();
}

//LED pour domestiques
if (readValue >= 700 && readValue < 1024) {
   turnOnPixels(255, 0, 0); // Rouge
}  

//servo 1
 reading = analogRead(potPin); // read the analog input
 angle = map(reading, 0, 1023, 0, 180); // map the input to a value between 0 and 180 degrees
 myservo1.write(angle); // tell the servo to go to the set position
delay(15); // wait 15 ms for the servo to reach the position

 reading = analogRead(potPin); // read the analog input
 angle = map(reading, 0, 1023, 0, 180); // map the input to a value between 0 and 180 degrees
 myservo2.write(angle); // tell the servo to go to the set position
delay(15); // wait 15 ms for the servo to reach the position

///BOUTON ROUGE + BOUTON BLEU

  if (digitalRead(Brouge) == LOW) {
    // Si l'interrupteur 1 est enfoncé, allumer en rouge
    turnOnPixels(255, 0, 0); // Rouge

  } else if (digitalRead(Bbleu) == LOW) {
    // Si l'interrupteur 2 est enfoncé, allumer en bleu
    turnOnPixels(0, 0, 255); // Bleu

  } else if (isOn) {
    // Si les LED sont déjà allumées et aucun interrupteur n'est enfoncé, les maintenir allumées
    turnOnPixels(lastRed, lastGreen, lastBlue); // Garder la dernière couleur allumée
  } else {
    // Sinon, éteindre les LED
    turnOffPixels();
  }
}

void turnOnPixels(uint8_t red, uint8_t green, uint8_t blue) {
  for (int i = 0; i < NEOPIXEL_COUNT; i++) {
    ring.setPixelColor(i, ring.Color(red, green, blue));
  }
  ring.show();
  isOn = true; // Définir l'état d'allumage à true
  lastRed = red; // Stocker les valeurs RVB de la dernière couleur utilisée
  lastGreen = green;
  lastBlue = blue;
}

void turnOffPixels() {
  for (int i = 0; i < NEOPIXEL_COUNT; i++) {
    ring.setPixelColor(i, ring.Color(0, 0, 0)); // Éteindre les LED (couleur noire)
  }
  ring.show();
  isOn = false; // Définir l'état d'allumage à false
}